#ifndef Window_h__
#define Window_h__

#include "nsWidget.h"

class BWindow;

class nsWindow : public nsWidget
{
public:
	nsWindow();
//	virtual ~nsWindow();
	
	NS_IMETHOD              WidgetToScreen(const nsRect& aOldRect, nsRect& aNewRect);
	NS_IMETHOD              ScreenToWidget(const nsRect& aOldRect, nsRect& aNewRect);

	NS_IMETHOD              ConstrainPosition(PRBool aAllowSlop,
	                                          PRInt32 *aX, PRInt32 *aY);


	NS_IMETHOD              Show(PRBool bState);

	NS_IMETHOD              Move(PRInt32 aX, PRInt32 aY);
	NS_IMETHOD              Resize(PRInt32 aWidth, PRInt32 aHeight, PRBool   aRepaint);
	NS_IMETHOD              Resize(PRInt32 aX, PRInt32 aY, PRInt32 aWidth, PRInt32 aHeight, PRBool   aRepaint);
	NS_IMETHOD              Scroll(PRInt32 aDx, PRInt32 aDy, nsRect *aClipRect);

	NS_IMETHOD              SetTitle(const nsAString& aTitle);
	
protected:
	virtual nsresult        StandardWindowCreate(nsIWidget *aParent,
	                                             const nsRect &aRect,
	                                             EVENT_CALLBACK aHandleEventFunction,
	                                             nsIDeviceContext *aContext,
	                                             nsIAppShell *aAppShell,
	                                             nsIToolkit *aToolkit,
	                                             nsWidgetInitData *aInitData,
	                                             nsNativeWidget aNativeParent = nsnull);

	BWindow *		mWindow;
};

//TQH: This might need it's own file as popups arn't supposed to have it's own event-handling (but rely on it's toplevel win)
class nsPopupWindow : public nsWindow
{
public:
	nsPopupWindow();
//	virtual ~nsPopupWindow();
	

	NS_IMETHOD              Show(PRBool bState);
/*
	NS_IMETHOD              Move(PRInt32 aX, PRInt32 aY);
	NS_IMETHOD              Resize(PRInt32 aWidth, PRInt32 aHeight, PRBool   aRepaint);
	NS_IMETHOD              Resize(PRInt32 aX, PRInt32 aY, PRInt32 aWidth, PRInt32 aHeight, PRBool   aRepaint);
	NS_IMETHOD              Scroll(PRInt32 aDx, PRInt32 aDy, nsRect *aClipRect);

	NS_IMETHOD              SetTitle(const nsAString& aTitle);
*/	
protected:
	virtual nsresult        StandardWindowCreate(nsIWidget *aParent,
	                                             const nsRect &aRect,
	                                             EVENT_CALLBACK aHandleEventFunction,
	                                             nsIDeviceContext *aContext,
	                                             nsIAppShell *aAppShell,
	                                             nsIToolkit *aToolkit,
	                                             nsWidgetInitData *aInitData,
	                                             nsNativeWidget aNativeParent = nsnull);

private:
};


#endif // Window_h__
